/*
 * Created on Jun 22, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.HashSet;
import java.util.Iterator;

import javax.imageio.ImageIO;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;
import javax.sound.sampled.DataLine;

/**
 * @author The World
 */
public class PlayScreen extends GameScreen
{
//   public void paint(Graphics2D g, Component c)
//   {
//      super.paint(g, c);
//      Rectangle rc = c.getBounds();
//      RenderBuffer buf = engine.render;
//      buf.copyBuffer( g, 0, 0,
//         buf.getWidth(), buf.getHeight(),
//         0, 0, buf.getWidth(), buf.getHeight());
//   }

   public void run()
   {
      super.run();

//      double angle = 0;
      Player player = new Player(engine);
      RotatingSprite spr = new RotatingSprite(engine.loadImage("tree.png"), 128, 128);
      RotatingSprite grass = new RotatingSprite(engine.loadImage("grass.png"), 0, 0);
      final long loopDuration = 50;
      long endLoopTime = System.currentTimeMillis() + loopDuration;
      long now = System.currentTimeMillis();
      long timeShift = 0;
      GameMap map = new GameMap(engine);
      map.player = player;
      Rectangle2D pr = new Rectangle2D.Double();
      player.boundingBox(pr);
      map.addToCollisionRegions(player, pr);
      int zoom = 0;
      
      while(true)
      {
         // Get input
         while (true)
         {
            UserEventQueueNode ev = engine.events.nextEvent();
            if (ev == null) break;
            if (ev.type == UserEventQueueNode.MOUSE_PRESS)
            {
               boolean isAttack = true;
               
               // If user clicked on an object that is clickable (activatable) then activate that object instead of attacking
               HashSet s = new HashSet();
               map.findAllCollisions(new CircleCollisionChecker(null, 
                     ev.x - engine.render.getWidth() / 2 + player.x, 
                     engine.render.getHeight() / 2 - ev.y + player.y, 1), s);
               Iterator it = s.iterator();
               while(it.hasNext())
               {
                  GameObject o = (GameObject)it.next();
                  if (o.isActivatable())
                  {
                     o.activate(player, now);
                     isAttack = false;
                     break;
                  }
               }

               if (isAttack)
                  player.mouseDown();
            }
            if (ev.type == UserEventQueueNode.MOUSE_MOVE)
            {
               player.mousePos(ev.x - engine.render.getWidth() / 2, engine.render.getHeight() / 2 - ev.y);
            }
            if (ev.type == UserEventQueueNode.KEY_PRESS)
            {
               if (ev.code == KeyEvent.VK_Z)
                  zoom--;
               else if (ev.code == KeyEvent.VK_A)
                  zoom++;
               else if (ev.code == KeyEvent.VK_S)
                  map.showPos = ! map.showPos;
               else if (ev.code == KeyEvent.VK_F)
                  map.fastWalk++;
               else if (ev.code == KeyEvent.VK_X)
                  map.noMove = ! map.noMove;
               if (zoom < 0) zoom = 0;
               if (zoom > 10) zoom = 10;
               if (map.fastWalk > 3)
                  map.fastWalk = 0;
            }
         }
         if (engine.events.isKeyDown(KeyEvent.VK_DOWN) && engine.events.isKeyDown(KeyEvent.VK_LEFT))
            player.keyMove(-1, -1);
         else if (engine.events.isKeyDown(KeyEvent.VK_DOWN) && engine.events.isKeyDown(KeyEvent.VK_RIGHT))
            player.keyMove(1, -1);
         else if (engine.events.isKeyDown(KeyEvent.VK_UP) && engine.events.isKeyDown(KeyEvent.VK_RIGHT))
            player.keyMove(1, 1);
         else if (engine.events.isKeyDown(KeyEvent.VK_UP) && engine.events.isKeyDown(KeyEvent.VK_LEFT))
            player.keyMove(-1, 1);
         else if (engine.events.isKeyDown(KeyEvent.VK_DOWN))
            player.keyMove(0, -1);
         else if (engine.events.isKeyDown(KeyEvent.VK_RIGHT))
            player.keyMove(1, 0);
         else if (engine.events.isKeyDown(KeyEvent.VK_UP))
            player.keyMove(0, 1);
         else if (engine.events.isKeyDown(KeyEvent.VK_LEFT))
            player.keyMove(-1, 0);
         else
            player.keyMove(0, 0);
         
         // Do game simulation
         if (!map.lose && !map.win)
            map.move(engine, now, player.x, player.y);
         
         // Draw some stuff
         Graphics2D g = engine.render.getGraphics();
         g.setColor(Color.WHITE);
         g.fillRect( 0, 0, engine.render.getWidth(), engine.render.getHeight());

         double scale = 1/Math.exp(zoom);

         AffineTransform oldTransform = g.getTransform();
         g.scale(1, -1);  // flip from world coordinates to screen coordinates
         g.scale(scale, scale);
         g.translate(-player.x + engine.render.getWidth() / scale / 2, -player.y - engine.render.getHeight() / scale / 2);  // center on player


         // Draw the background and all game objects on the map (including the player)
         map.draw(engine, g, player.x, player.y, engine.render.getWidth() / scale, engine.render.getHeight() / scale);
         engine.drawDelayedText(g);
         
         // Draw the player
         //player.draw(engine);
         
/*
       Graphics2D g2 = engine.render.getGraphics();
       Font font = new Font("Dialog", Font.BOLD, 24);
       g2.setFont(font);
       g2.setColor(Color.black);

       g2.drawString("Initializing and Loading Images", 0, 20);
*/
//         engine.render.drawImage(img, ev.x, ev.y);
//         angle += 0.05;
//         engine.drawSprite(spr, ev.x, ev.y, angle);

         g.setTransform(oldTransform);

         Font font = new Font("Dialog", Font.BOLD, 24);
         Font oldFont = g.getFont();
         Color oldColor = g.getColor();

         g.setFont(font);
         g.setColor(Color.black);
         if (map.showPos)
            g.drawString("Pos: " + player.x + ", " + player.y, 3, engine.render.getHeight() - 5);
         else
            g.drawString("Hit Points: " + player.hitpoints, 3, engine.render.getHeight() - 5);

         if (map.win || map.lose)
         {
            font = new Font("Dialog", Font.BOLD, 50);
            g.setFont(font);
            if (((now / 1000) % 2) == 0)
               g.setColor(Color.black);
            else
               g.setColor(Color.red);
            if (map.lose)
               g.drawString("You lose!", 50, 50);
            else if (map.win)
               g.drawString("You win!", 50, 50);
            g.setFont(oldFont);
            g.setColor(oldColor);
         }

         g.setFont(oldFont);
         g.setColor(oldColor);

         
         engine.render.releaseGraphics();
         engine.switchBuffer();         


//         long currentLoopTime = System.currentTimeMillis() - loopTime;
         now = System.currentTimeMillis() + timeShift;
         while (now < endLoopTime)
         {
            Thread.yield();
   /*       try {
               Thread.sleep(100 - currentLoopTime);
            } catch (java.lang.InterruptedException err)
            {
            }*/
//            currentLoopTime = System.currentTimeMillis() - loopTime;
            now = System.currentTimeMillis() + timeShift;
         }
         endLoopTime = endLoopTime + loopDuration;
         if (endLoopTime - now < - loopDuration)
            endLoopTime = now + loopDuration;  // Things are too far out of sync--reset
//         loopTime = System.currentTimeMillis() - (currentLoopTime - 100);
      }
   }

   /**
    * 
    */
   public PlayScreen(GameEngine engine)
   {
      super(engine);
   }

}
