/*
 * Created on Jun 24, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.util.HashSet;
import java.util.Iterator;

/**
 * @author The World
 */
public class Player extends GameObject
{
   RotatingSprite legImgs [] = new RotatingSprite[3];
   RotatingSprite torsoImgs [] = new RotatingSprite[4];
   RotatingSprite headImgs[] = new RotatingSprite[1];
   SoundClip damageClip, swordClip;

   static final int MAX_HIT_POINTS = 100;
   
   double x = 300;
   double y = 300;
//   double x = 8300;
//   double y = 4000;
   int hitpoints = MAX_HIT_POINTS;

   double legangle = 0;
   double headangle = 0;
   double torsoangle = 0;
   double mouseangle = 0;
   static final double CollisionCircleSize = 50;
   static final double AttackDistance = 76 + 18;
   static final int AttackDamage = 10;
   
   int mouseClicked = 0;
   long attackStartTime = -1;
   static final int ATTACK_EXTEND = 0;
   static final int ATTACK_REST = 1;
   int attackPos = ATTACK_EXTEND;
   long attackExtendTime = 250;
   long attackRestTime = 350;  // should be longer than attackExtendTime
   long attackTorsoTime = 1500;  // should be longer than attackRestTime (time torso remains facing enemy)
   
   boolean keyspecified = false;
   int keydx = 0;
   int keydy = 0;
   double keyangle = 0;
   static final int LEG_CENTER = 0;
   static final int LEG_LEFT = 1;
   static final int LEG_CENTER_RIGHT = 2;
   static final int LEG_RIGHT = 3;
   static final int LEG_NUM = 4;
   int legpos = LEG_CENTER;
   static final int MoveAmount = 30;
   long lastLegPosTime = -1;
   long legAdvanceTime = 250;
  
   void keyMove(int dx, int dy)
   {
      keydx = dx;
      keydy = dy;
      keyspecified = (dx != 0 || dy != 0);
      if (keyspecified)
      {
         keyangle = Math.atan2(dy, dx);
      }
   }
   
   void mousePos(double mx, double my)
   {
      mouseangle = Math.atan2(my /*- y*/, mx /*- x*/);
   }
   
   void mouseDown()
   {
      mouseClicked++;
   }
   
   static double constrain(double angle)
   {
      while (angle > Math.PI) angle -= Math.PI * 2;
      while (angle < -Math.PI) angle += Math.PI * 2;
      return angle;
   }

   boolean checkCollision(CollisionChecker check)
   {
      return check.checkCircleCollision(x, y, CollisionCircleSize);
   }

   void boundingBox(java.awt.geom.Rectangle2D r)
   {
      r.setRect(x - CollisionCircleSize, y - CollisionCircleSize, 
            2 * CollisionCircleSize, 2 * CollisionCircleSize);
   }
   
   void doMove(long now, GameMap map)
   {
      if (hitpoints <= 0)
      {
         map.lose = true;
         return;
      }
      
//      double torsodrift = 0.05;
      boolean torsoAngleLock = false;

      // Cancel torso facing for attack mode if time ended
      if (attackStartTime >= 0 && now - attackStartTime >= attackTorsoTime)
      {
         attackStartTime = -1;
      }
      
      // Do any attacks, if possible
      if ((attackStartTime < 0 || now - attackStartTime >= attackRestTime) && mouseClicked > 0)
      {
         mouseClicked = 0;
         attackStartTime = now;
         
         HashSet s = new HashSet();
         map.findAllCollisions(new CircleCollisionChecker(this, x + Math.cos(mouseangle) * AttackDistance, 
               y + Math.sin(mouseangle) * AttackDistance, 1), s);
         Iterator it = s.iterator();
         while(it.hasNext())
         {
            GameObject o = (GameObject)it.next();
            if (o.isEnemy())
            {
               o.doDamage(AttackDamage);
               swordClip.play();
               break;
            }
         }

      }
      
      // legangle is determined by what keys the user has pressed
      if (keyspecified)
         legangle = keyangle;

      // head always faces where the mouse is pointed 
      headangle = mouseangle;
      
      // If fighting (i.e. mouse button pressed), then torso aligns with head
      if (attackStartTime >= 0)
      {
         torsoangle = headangle;
         torsoAngleLock = true;
      }
      
      // the angle between the head and torso cannot exceed 90 degrees
      if (Math.abs(constrain(torsoangle - headangle)) > Math.PI / 2)
      {
         if (constrain(torsoangle - headangle) < 0)
            torsoangle = headangle - Math.PI / 2;
         else
            torsoangle = headangle + Math.PI / 2;
      }
      
      // the angle betweent the torso and legs cannot exceed 90 degrees
      if (Math.abs(constrain(legangle - torsoangle)) > Math.PI / 2)
      {
         if (!keyspecified)
         {
            // if user is not forcing a current facing for the legs, then rotate the legs
            // TODO(iu): This doesn't look quite right. A walk animation might make it look better.
            //            Another possibility is to let the angle between head and torso exceed 90 degrees
            if (constrain(legangle - torsoangle) < 0)
            {
               while (Math.abs(constrain(legangle - torsoangle)) > Math.PI / 2)
                  legangle += Math.PI / 4;
            }
            else
            {
               while (Math.abs(constrain(legangle - torsoangle)) > Math.PI / 2)
                  legangle -= Math.PI / 4;
            }
         }
         else
         {
            // the user is forcing the character to walk in a certain direction, but we can have the
            // character walk backwards so that the angle stays below 90 degrees
            legangle = constrain(legangle + Math.PI);
         }
//         torsoAngleLock = true;
      }

      if (!torsoAngleLock)
      {
         // if the angle between the head and legs is greater than 90 degrees, but the angle
         // between the torso is rotated more than necessary to maintain the 90 degree angle
         // between head and torso, then rotate the torso back.
         if (Math.abs(constrain(headangle - legangle)) > Math.PI / 2
               && Math.abs(constrain(headangle - torsoangle)) < Math.PI / 2)
         {
            if (constrain(torsoangle - headangle) < 0)
               torsoangle = headangle - Math.PI / 2;
            else
               torsoangle = headangle + Math.PI / 2;
         }
   
         // if the angle between the head and legs is less than 90 degrees, we should adjust the torso
         // so that it aligns with the legs
         if (Math.abs(constrain(headangle - legangle)) < Math.PI / 2)
         {
            torsoangle = legangle;
         }
      }
      
      // Choose the frame of animation for the legs
      if (!keyspecified)
      {
         legpos = LEG_CENTER;
         lastLegPosTime = now;
      }
      else
      {
         if (lastLegPosTime >= 0)
         {
            if (now - lastLegPosTime > legAdvanceTime)
            {
               lastLegPosTime = lastLegPosTime + legAdvanceTime;
               legpos++;
               if (legpos >= LEG_NUM)
                  legpos = LEG_CENTER;
               
//               double newx = x + keydx * MoveAmount;
//               double newy = y + keydy * MoveAmount;
//               if (!map.checkCollision(new CircleCollisionChecker(newx, newy, CollisionCircleSize)))
//               {
//                  x = newx;
//                  y = newy;
//               }
               double minMove = 0;
               double maxMove = MoveAmount * Math.exp(map.fastWalk);
               while(maxMove - minMove > 0.5)
               {
                  double moveStep = (minMove + maxMove) / 2;
                  double newx = x + keydx * moveStep;
                  double newy = y + keydy * moveStep;
                  if (!map.checkCollision(new CircleCollisionChecker(this, newx, newy, CollisionCircleSize)))
                     minMove = moveStep;
                  else
                     maxMove = moveStep;
               }
               Rectangle2D r = new Rectangle2D.Double();
               boundingBox(r);
               map.removeFromCollisionRegions(this, r);
               x = x + keydx * minMove;
               y = y + keydy * minMove;
               boundingBox(r);
               map.addToCollisionRegions(this, r);
            }
         }
         else
         {
            lastLegPosTime = now;
         }
      }
      
      // Do animation for attacking
      if (attackStartTime >= 0)
      {
         if (now - attackStartTime < attackExtendTime)
         {
            attackPos = ATTACK_EXTEND;
         } 
         else 
         {
            attackPos = ATTACK_REST;
         }
      }
      
   }
   
   void draw(GameEngine e, Graphics2D g)
   {
      int legframe = 0;
      int torsoframe = 0;
      if (legpos == LEG_LEFT) 
      {
         torsoframe = 2;
         legframe = 1;
      }
      if (legpos == LEG_RIGHT)
      {
         torsoframe = 1;
         legframe = 2;
      }
      e.drawSprite(legImgs[legframe], x, y, legangle - Math.PI/2);

      if (attackStartTime >= 0)
      {
         torsoframe = 0;
         if (attackPos == ATTACK_EXTEND)
            torsoframe = 3;
      }
      e.drawSprite(torsoImgs[torsoframe], x, y, torsoangle - Math.PI/2);
      e.drawSprite(headImgs[0], x, y, headangle - Math.PI/2);
   }

   /**
    * 
    */
   public Player(GameEngine e)
   {
      super();
      int frontToCenter = 18;
      legImgs[0] = new RotatingSprite(e.loadImage("legs.png"), 50, 4 + frontToCenter);
      legImgs[1] = new RotatingSprite(e.loadImage("legsleft.png"), 50, 40 + frontToCenter);
      legImgs[2] = new RotatingSprite(e.loadImage("legsright.png"), 50, 40 + frontToCenter);
      torsoImgs[0] = new RotatingSprite(e.loadImage("torso.png"), 50, 35 + frontToCenter);
      torsoImgs[1] = new RotatingSprite(e.loadImage("torsoleft.png"), 50, 26 + frontToCenter);
      torsoImgs[2] = new RotatingSprite(e.loadImage("torsoright.png"), 50, 44 + frontToCenter);
      torsoImgs[3] = new RotatingSprite(e.loadImage("torsoextend.png"), 50, 76 + frontToCenter);
      headImgs[0] = new RotatingSprite(e.loadImage("head.png"), 25, 27);
      damageClip = e.loadSound("thump1.wav");
      swordClip = e.loadSound("ting2.wav");

   }

   void doDamage(int damage) {hitpoints -= damage; if (!damageClip.isRunning()) damageClip.play();}
   void doHealth(int healing) {hitpoints += healing; if (hitpoints > MAX_HIT_POINTS) hitpoints = MAX_HIT_POINTS; }
   boolean isPlayer() { return true; }

}
