/*
 * Created on Aug 11, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

/**
 * @author The World
 */
public class SoundClip implements LineListener {

   AudioFormat af;
   DataLine.Info info;
   byte [] data;
   Clip lastClip;
   /**
    * 
    */
   public SoundClip(URL in) {
      ClassLoader cl = this.getClass().getClassLoader();
      try {
         AudioInputStream audioInputStream = AudioSystem.getAudioInputStream(in);
         af = audioInputStream.getFormat();
         info = new DataLine.Info(Clip.class, audioInputStream.getFormat());
         data = new byte[(int) (audioInputStream.getFrameLength() * audioInputStream.getFormat().getFrameSize())];
         audioInputStream.read(data, 0, data.length);
         audioInputStream.close();
      } catch (UnsupportedAudioFileException e) {
         e.printStackTrace();
      } catch (IOException e) {
         e.printStackTrace();
      }
   }

   public void play() 
   {
      Clip clip;
      try {
         clip = (Clip) AudioSystem.getLine(info);
         clip.open(af, data, 0, data.length);
         clip.addLineListener(this);
         clip.setFramePosition(0);
         clip.start();
         lastClip = clip;
      } catch (LineUnavailableException e) {}
   }
   
   public boolean isRunning()
   {
      if (lastClip != null)
         return lastClip.isRunning();
      else
         return false;
   }
   
   public void update(LineEvent e) {
      if (e.getType() == LineEvent.Type.STOP)
      {
         //((Clip)e.getLine()).stop();
         e.getLine().close();
      }
   }

}
