/*
 * Created on Jul 26, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

/**
 * @author The World
 */
public class TreeObject extends GameObjectWithPos {
   static final double CollisionCircleSize = 128;
   static RotatingSprite treeImg;
   static RotatingSprite deadImg;
   boolean isDead;
   
   /**
    * 
    */
   public TreeObject(GameEngine e, double x, double y, boolean dead) {
      super();
      // TODO: NOT SYNCHRONIZED!
      if (treeImg == null)
      {
         treeImg = new RotatingSprite(e.loadImage("tree.png"), 128, 128);
         deadImg = new RotatingSprite(e.loadImage("deadtree.png"), 128, 128);
      }
      this.isDead = dead;
      this.x = x;
      this.y = y;
   }

   void draw(GameEngine e, Graphics2D g)
   {
      if (isDead)
         e.drawSprite(deadImg, x, y, 0);
      else
         e.drawSprite(treeImg, x, y, 0);
   }

   boolean checkCollision(CollisionChecker check)
   {
      return check.checkCircleCollision(x, y, CollisionCircleSize);
   }
   
   void boundingBox(java.awt.geom.Rectangle2D r)
   {
      r.setRect(x - CollisionCircleSize, y - CollisionCircleSize, 
            2 * CollisionCircleSize, 2 * CollisionCircleSize);
   }
}
