/*
 * Created on Jun 22, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.util.HashMap;
import java.util.LinkedList;
import java.awt.event.KeyEvent;

/**
 * @author The World
 */
public class UserEventQueue
{
   //TODO: Use a pool to reuse linked list objects and real objects

   LinkedList events = new LinkedList();
   
   // TODO: This isn't scalable is the range is too large
   HashMap downkeys = new HashMap();

   public boolean isKeyDown(int key)
   {
      synchronized(downkeys)
      {
         return downkeys.get(new Integer(key)) != null;
      }
   }

   public void keyPress(int key)
   {
      synchronized(downkeys)
      {
         downkeys.put(new Integer(key), Boolean.TRUE);
      }
      addEvent(new UserEventQueueNode(UserEventQueueNode.KEY_PRESS, 0, 0, key));
   }

   public void keyRelease(int key)
   {
      synchronized(downkeys)
      {
         downkeys.put(new Integer(key), null);
      }
      addEvent(new UserEventQueueNode(UserEventQueueNode.KEY_RELEASE, 0, 0, key));
   }

   public synchronized void mouseMove(int x, int y)
   {
      if (!events.isEmpty())
      {
         UserEventQueueNode node = (UserEventQueueNode)events.getFirst();
         if (node.type == UserEventQueueNode.MOUSE_MOVE)
         {
            node.x = x;
            node.y = y;
            return;
         }
      }
      addEvent(new UserEventQueueNode(UserEventQueueNode.MOUSE_MOVE, x, y, 0));
   }

   public void mousePress(int x, int y)
   {
      addEvent(new UserEventQueueNode(UserEventQueueNode.MOUSE_PRESS, x, y, 0));
   }

   public void mouseRelease(int x, int y)
   {
      addEvent(new UserEventQueueNode(UserEventQueueNode.MOUSE_RELEASE, x, y, 0));
   }

   synchronized void addEvent(UserEventQueueNode ev)
   {
      events.add(ev);
   }

   public synchronized UserEventQueueNode nextEvent()
   {
      if (events.isEmpty())
         return null;
      return (UserEventQueueNode)events.removeFirst();
   }

   /**
    * 
    */
   public UserEventQueue()
   {
      super();
   }

}
