/*
 * Created on Jul 26, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.font.FontRenderContext;
import java.awt.font.LineBreakMeasurer;
import java.awt.font.TextAttribute;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.text.AttributedString;
import java.util.Hashtable;
import java.util.Iterator;

/**
 * @author The World
 */
public class VillagerObject extends GameObjectWithPos {
   static final double CollisionCircleSize = 50;
   static RotatingSprite villagerImg;
   static RotatingSprite leaderImg;
   double angle;
   boolean leader;
   String statement;
   long lastActivated = -1;
   static final long ACTIVATION_TIME = 7000;
   static final int TEXT_WIDTH = 300;
   
   /**
    * 
    */
   public VillagerObject(GameEngine e, int leader, double x, double y, double angle, String statement) {
      super();
      // TODO: NOT SYNCHRONIZED!
      if (villagerImg == null)
         villagerImg = new RotatingSprite(e.loadImage("villager.png"), 50, 31);
      if (leaderImg == null)
         leaderImg = new RotatingSprite(e.loadImage("villagerleader.png"), 50, 31);
      this.x = x;
      this.y = y;
      this.angle = angle;
      this.leader = (leader != 0);
      this.statement = statement;
   }

   void draw(GameEngine e, Graphics2D g)
   {
      if (leader)
         e.drawSprite(leaderImg, x, y, angle - Math.PI / 2);
      else
         e.drawSprite(villagerImg, x, y, angle - Math.PI / 2);
      if (lastActivated >= 0)
      {
         e.addDelayedCenteredText(x, y, TEXT_WIDTH, statement);
      }
   }

   boolean checkCollision(CollisionChecker check)
   {
      return check.checkCircleCollision(x, y, CollisionCircleSize);
   }
   
   void boundingBox(java.awt.geom.Rectangle2D r)
   {
      r.setRect(x - CollisionCircleSize, y - CollisionCircleSize, 
            2 * CollisionCircleSize, 2 * CollisionCircleSize);
   }

   void doMove(long now, GameMap map) 
   {
      if (lastActivated >= 0 && now - lastActivated > ACTIVATION_TIME)
         lastActivated = -1;
   }

   boolean isActivatable() { return true; }

   void activate(GameObject activator, long now)
   {
      lastActivated = now;
      angle = Math.atan2(((Player)activator).y - y, ((Player)activator).x - x);
   }
}
