/*
 * Created on Aug 2, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

/**
 * @author The World
 */
public class WallObject extends GameObjectWithPos {
   static final double WallWidth = 50;
   static final double CollisionCircleSize = 128;
   static RotatingSprite wallImg;
   
   /**
    * 
    */
   public WallObject(GameEngine e, double x, double y) {
      super();
      // TODO: NOT SYNCHRONIZED!
      if (wallImg == null)
         wallImg = new RotatingSprite(e.loadImage("wall.png"), 0, WallWidth);
      this.x = x;
      this.y = y;
   }

   void draw(GameEngine e, Graphics2D g)
   {
      e.drawSprite(wallImg, x, y, 0);
   }

   boolean checkCollision(CollisionChecker check)
   {
      if (check.checkLineCollision(x, y, x + WallWidth, y)) return true;
      if (check.checkLineCollision(x, y, x, y + WallWidth)) return true;
      if (check.checkLineCollision(x + WallWidth, y, x + WallWidth, y + WallWidth)) return true;
      if (check.checkLineCollision(x, y + WallWidth, x + WallWidth, y + WallWidth)) return true;
      return false;
   }
   
   void boundingBox(java.awt.geom.Rectangle2D r)
   {
      r.setRect(x, y, WallWidth, WallWidth); 
   }
}
