/*
 * Created on Aug 2, 2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package org.programmingbasics.iu.game;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.util.HashSet;
import java.util.Iterator;

/**
 * @author The World
 */
public class WinningCrystalObject extends GameObjectWithPos {
   static RotatingSprite crystalImg;
   double angle;
   static final double CircleCollisionSize = 19;
   
   /**
    * 
    */
   public WinningCrystalObject(GameEngine e, double x, double y) {
      super();
      // TODO: NOT SYNCHRONIZED!
      if (crystalImg == null)
      {
         crystalImg = new RotatingSprite(e.loadImage("crystal.png"), 15, 19);
      }
      this.angle = Math.PI / 2;
      this.x = x;
      this.y = y;
   }

   void draw(GameEngine e, Graphics2D g)
   {
      e.drawSprite(crystalImg, x, y, angle - Math.PI / 2);
   }

   boolean checkCollision(CollisionChecker check)
   {
      return false;  // things cannot collide with a potion
   }
   
   void boundingBox(java.awt.geom.Rectangle2D r)
   {
      r.setRect(x - CircleCollisionSize / 2, y - CircleCollisionSize / 2, 
            CircleCollisionSize * 2, CircleCollisionSize * 2);
   }

   void doMove(long now, GameMap map) 
   {
      // Check if player has walked over us. If so, give them health
      HashSet collided = new HashSet();
      map.findAllCollisions(new CircleCollisionChecker(this, x, y, CircleCollisionSize), collided);

      if (!collided.isEmpty())
      {
         Iterator it = collided.iterator();
         while (it.hasNext())
         {
            GameObject obj = (GameObject)it.next(); 
            if (obj.isPlayer())
            {
               map.win = true;
               map.removeGameObject(this);
            }
         }
         return;
      }
   }
}
